$regfile = "m168pdef.dat"
$crystal = 8000000
$hwstack = 40
$swstack = 16
$framesize = 32

Config Lcd = 16 * 2
Config Lcdpin = Pin , Db4 = Portd.3 , Db5 = Portd.2 , Db6 = Portd.1 , Db7 = Portd.0 , E = Portd.4 , Rs = Portb.7 , Wr = Portb.6

Config Sda = Portc.4
Config Scl = Portc.5
Config I2cdelay = 10

Config 1wire = Portc.2

Dim Calc As Single , Calc2 As Single , Calc1 As Single , Calc3 As Single
Dim Vosh As Word , Zah As Word
Dim Utro As Word , Vech As Word , Timetek As Word
Dim Mine As Byte , Hour As Byte , Dat As Byte , Month As Byte , Year As Byte , Period As Byte , Olddat As Byte , Day As Byte
Dim Mine1 As Word , Hour1 As Word ,
Dim Dataword1 As Word
Dim Tau As Single , M As Single , L As Single , Ra As Single , Lnghour As Single , La As Single , Lo As Single , Offs As Byte , Squar As Byte
Dim Cost As Single
Dim Key As Byte , Temp As Word , Temp1 As Word
Dim Ss As String * 12 , Razd As String * 1
Dim Dtt As Single , Dt As Byte
Dim Loe As Eram Single , Lae As Eram Single , Offse As Eram Byte , Square As Eram Byte
Dim W As Integer , Light As Word , Poroge As Eram Word , Porog As Word
Dim Sw As Byte , Oldsw As Byte , Night As Byte , Avsw As Byte , N As Word , X As Byte
Dim T1 As Word , T2 As Word , T3 As Word , T4 As Word
Dim Look As Byte , Dvr As Byte , Dvre As Eram Byte , Sign As Byte

Config Adc = Single , Prescaler = Auto , Reference = Avcc

Config Portb.2 = Input
Config Portb.3 = Input
Config Portb.4 = Input
Config Portb.5 = Input
Config Portd.7 = Output
Reset Portd.7
Svet Alias Portd.7
Razd = " "

I2cinit
I2cstart                                                    ' 
I2cwbyte &HD0
I2cwbyte &H00
I2cwbyte &H00
I2cstop



Config Watchdog = 2048
Start Watchdog



Newday:

Reset Watchdog

Cls

Porog = Poroge
If Porog = 0 Or Porog = 65535 Then Porog = 700
Dvr = Dvre
If Dvr > 30 Then Dvr = 30





Avsw = 0 : Look = 0                                         '    

Lo = Loe : La = Lae : Offs = Offse : Squar = Square

Gosub Vremia                                                '  
Olddat = Dat

If Offs > 30 Or Squar > 12 Then                             '   
   Offs = 20 : Squar = 3 : La = 55.5 : Lo = 37.5
   Goto Menu
End If

Locate 1 , 1
Ss = Str(dat)
Lcd Format(ss , "00") ; "-";
Ss = Str(month)
Lcd Format(ss , "00") ; "-";
Ss = Str(year)
Lcd Format(ss , "00")

Dataword1 = 2000 + Year                                     ' -

Calc1 = 275 * Month
Calc1 = Calc1 / 9
Calc1 = Int(calc1)

Calc2 = Month + 9
Calc2 = Calc2 / 12
Calc2 = Int(calc2)

Calc = Dataword1 / 4
Calc = Int(calc)
Calc = Calc * 4
Calc = Dataword1 - Calc
Calc = Calc + 2
Calc = Calc / 3
Calc = Int(calc)
Calc3 = Calc + 1

Dataword1 = Calc2 * Calc3
Dataword1 = Calc1 - Dataword1
Dataword1 = Dataword1 + Dat
Dataword1 = Dataword1 - 30

Lnghour = Lo / 15

Vosh = 10

Period = 0
Gosub Sun
Vosh = Calc
Utro = Vosh + Offs
T1 = Utro - Dvr
T2 = Utro + Dvr

Period = 1
Gosub Sun
Zah = Calc
Vech = Zah - Offs
T3 = Vech - Dvr
T4 = Vech + Dvr



Temp = 1440 - Zah
If Temp <= Offs Or Vosh = 0 Or Utro >= Vech Then            ' 
   Period = 4                                               'Utro = 0 : Vech = 1440
   Goto 100
End If

Temp = 1440 - Vosh
If Temp <= Offs Or Vosh = 1440 Then                         ' 
   Period = 5                                               'Utro = 1440 : Vech = 0
   Goto 100
End If




50:
Locate 2 , 1

Hour1 = Utro \ 60
Mine1 = Utro Mod 60

Ss = Str(hour1)
Lcd Format(ss , "00") ; ":";
Ss = Str(mine1)
Lcd Format(ss , "00") ; "   ";

Hour1 = Vech \ 60
Mine1 = Vech Mod 60
Locate 2 , 12
Ss = Str(hour1)
Lcd Format(ss , "00") ; ":";
Ss = Str(mine1)
Lcd Format(ss , "00")


100:

Reset Watchdog

Cursor Off
Waitms 300





   Night = 255                                              ' 
   Light = Getadc(3)
   Gosub Klimat
   Gosub Compens

   If N < Porog Then Set Sw Else Reset Sw                   ' .   swith=1   - 
   Oldsw = Sw
      If Sw = Oldsw Then Incr X Else X = 0                  ' ..  10 
   If X = 10 Then
      Night = Sw                                            '     1 -  0 - 
      X = 0
   End If







Key = 255
Gosub Keyb
If Key = 64 Then
   Stop Watchdog
   Wait 2
   If Key = 64 Then Goto Menu
   Start Watchdog
   Goto 100
End If

Gosub Vremia
If Dat <> Olddat Then Goto Newday
If Razd = " " Then Razd = ":" Else Razd = " "


'  

Timetek = Hour * 60
Timetek = Timetek + Mine

If Avsw = 1 Then Incr Look Else Look = 0
If Look > 7 Then Look = 0

If Look < 4 Then
   Locate 1 , 12
   Ss = Str(hour)
   Lcd Format(ss , "00") ;
   Lcd Razd;
   Ss = Str(mine)
   Lcd Format(ss , "00")
   Goto 120
End If

Locate 1 , 12
Lcd "!CB! "



120:

'   0-, 1-, 2 -, 3-, 4-, 5- 

If Period = 4 Then                                          '.
   Locate 2 , 2
   Lcd "opù e"
   Reset Svet
   Goto 100
End If

If Period = 5 Then                                          '.
   Locate 2 , 2
   Lcd "opa o"
   Set Svet
   Goto 100
End If

If Timetek < T1 Or Timetek >= T4 Then Period = 0
If Timetek >= T1 And Timetek < T2 Then Period = 1
If Timetek >= T2 And Timetek < T3 Then Period = 2
If Timetek >= T3 And Timetek < T4 Then Period = 3


'         (  )

If Period = 0 And Night = 0 Then Avsw = 1
If Period = 2 And Night = 1 Then Avsw = 1

If Avsw = 1 Then
   If Timetek >= Utro And Timetek < Vech Then Period = 2 Else Period = 0
End If

' 

If Period = 0 Then Set Svet
If Period = 2 Then Reset Svet
If Period = 1 And Night = 0 Then Reset Svet
If Period = 3 And Night = 1 Then Set Svet



Locate 2 , 9
If Svet = 1 Then Lcd "*" Else Lcd " "

Goto 100




Menu:

Stop Watchdog
Cursor Blink

210:
Cls : Locate 1 , 1
Lcd "co"

215:
Locate 2 , 2
Ss = Str(dat)
Lcd Format(ss , "00") ;
Locate 2 , 2
Gosub Keyb

If Key > 3 Then Goto 215
On Key Goto 215 , 220
If Key = 3 Then Dt = 1 Else Dt = 255

Dat = Dat + Dt
If Dat > 31 Or Dat = 0 Then Dat = 1
Goto 215



220:
Cls : Locate 1 , 1
Lcd "Mec (pa)"

225:
Locate 2 , 2
Ss = Str(month)
Lcd Format(ss , "00") ;
Locate 2 , 2
Gosub Keyb

If Key > 3 Then Goto 225
On Key Goto 210 , 230
If Key = 3 Then Dt = 1 Else Dt = 255
Month = Month + Dt
If Month > 12 Or Month = 0 Then Month = 1
Goto 225



230:
Cls : Locate 1 , 1
Lcd "o"
Locate 2 , 2
Lcd "20";

235:
Locate 2 , 4
Ss = Str(year)
Lcd Format(ss , "00") ;
Locate 2 , 4
Gosub Keyb

If Key > 3 Then Goto 235
On Key Goto 220 , 240
If Key = 3 Then Dt = 1 Else Dt = 255

Year = Year + Dt
If Year > 30 Then Year = 0
Goto 235


240:
Cls : Locate 1 , 1
Lcd "ac"

245:
Locate 2 , 2
Ss = Str(hour)
Lcd Format(ss , "00")
Locate 2 , 2
Gosub Keyb

If Key > 3 Then Goto 245
On Key Goto 230 , 250
If Key = 3 Then Dt = 1 Else Dt = 255

Hour = Hour + Dt
If Hour > 23 Then Hour = 0
Goto 245



250:
Cls : Locate 1 , 1
Lcd "My"

255:
Locate 2 , 2
Ss = Str(mine)
Lcd Format(ss , "00")
Locate 2 , 2
Gosub Keyb

If Key > 3 Then Goto 255
On Key Goto 240 , 260
If Key = 3 Then Dt = 1 Else Dt = 255

Mine = Mine + Dt
If Mine > 59 Then Mine = 0
Goto 255

260:                                                        ' 
Cls : Locate 1 , 1
Lcd "acoo oc"

265:
Locate 2 , 2
Ss = Str(squar)
Lcd Format(ss , "00")
Locate 2 , 2
Gosub Keyb

If Key > 3 Then Goto 265
On Key Goto 250 , 270
If Key = 3 Then Dt = 1 Else Dt = 255

Squar = Squar + Dt
If Squar > 12 Then Squar = 12
Goto 265

270:                                                        '
Cls : Locate 1 , 1
Lcd "poa, pa."

275:
Locate 2 , 1
Ss = Fusing(la , "##.#")
If La < 10 Then Ss = " " + Ss
Lcd Ss

If La < 10 Then Locate 2 , 2 Else Locate 2 , 1
Gosub Keyb

If Key > 3 Then Goto 275
On Key Goto 260 , 277
If Key = 3 Then Dtt = 1 Else Dtt = -1

La = La + Dtt
If La > 69 Then La = 69
If La < 0 Then La = 0
Goto 275


277:

Locate 2 , 1
Ss = Fusing(la , "##.#")
If La < 10 Then Ss = " " + Ss
Lcd Ss

Locate 2 , 4
Gosub Keyb

If Key > 3 Then Goto 277
On Key Goto 275 , 280
If Key = 3 Then Dtt = 0.1 Else Dtt = -0.1

La = La + Dtt
If La > 69.9 Then La = 69.9
If La < 0 Then La = 0
Goto 277

280:

Cls : Locate 1 , 1
Lcd "ooa, pa."                                        '

285:
Locate 2 , 1
Ss = Fusing(lo , "###.#")
If Lo < 100 Then Ss = " " + Ss
Lcd Ss

If Lo < 100 Then Locate 2 , 2 Else Locate 2 , 1
Gosub Keyb

If Key > 3 Then Goto 285
On Key Goto 270 , 287
If Key = 3 Then Dtt = 1 Else Dtt = -1

Lo = Lo + Dtt
If Lo > 180 Then Lo = 180
If Lo < 10 Then Lo = 10
Goto 285


287:

Locate 2 , 1
Ss = Fusing(lo , "###.#")
If Lo < 100 Then Ss = " " + Ss
Lcd Ss

Locate 2 , 5
Gosub Keyb

If Key > 3 Then Goto 287
On Key Goto 275 , 290
If Key = 3 Then Dtt = 0.1 Else Dtt = -0.1

Lo = Lo + Dtt
If Lo > 180 Then Lo = 180
If Lo < 10 Then Lo = 10
Goto 287


290:                                                        '  
Cls : Locate 1 , 1
Lcd "Ceee, ."

295:
Locate 2 , 2
Ss = Str(offs)
Lcd Format(ss , "00")
Locate 2 , 2
Gosub Keyb

If Key > 3 Then Goto 295
On Key Goto 280 , 300
If Key = 3 Then Dt = 1 Else Dt = 255

Offs = Offs + Dt
If Offs > 35 Then Offs = 35

Goto 295




300:                                                        ' 
Cls : Locate 1 , 1
Lcd "oypa :"

If Dvr > 30 Then Dvr = 30


305:
Locate 2 , 1
Ss = Str(dvr)
Lcd Format(ss , "00")
Locate 2 , 1
Gosub Keyb

If Key > 3 Then Goto 305
On Key Goto 290 , 310
If Key = 3 Then Dt = 1 Else Dt = 255

Dvr = Dvr + Dt
If Dvr > 30 Then Dvr = 30
If Dvr < 15 Then Dvr = 15
Goto 305



310:                                                        '  


Cls : Locate 1 , 1
Cursor Off
Lcd "opo CB:      "
Locate 1 , 11
Lcd N
Locate 2 , 1
Lcd "'+' - Oo"

315:


Light = Getadc(3)

Gosub Klimat
Gosub Compens

Locate 1 , 11
Lcd "     "
Locate 1 , 11
Lcd N


Gosub Keyb
If Key > 3 Then Goto 315
If Key = 0 Then Goto 300
If Key = 3 Then Poroge = N





400:                                                        '

Cursor Off

Mine = Makebcd(mine)
Hour = Makebcd(hour)
Day = Makebcd(day)
Dat = Makebcd(dat)
Month = Makebcd(month)
Year = Makebcd(year)

I2cinit
I2cstart
I2cwbyte &HD0
I2cwbyte 0
I2cwbyte 0
I2cwbyte Mine
I2cwbyte Hour
I2cwbyte Day
I2cwbyte Dat
I2cwbyte Month
I2cwbyte Year
I2cstop

Lae = La : Loe = Lo : Square = Squar : Offse = Offs : Dvre = Dvr

Start Watchdog

Goto Newday







Vremia:

I2cstart
I2cwbyte &HD0
I2cwbyte &H00
I2cstart
I2cwbyte &HD1
I2crbyte Mine , Ack
I2crbyte Mine , Ack
I2crbyte Hour , Ack
I2crbyte Dat , Ack
I2crbyte Dat , Ack
I2crbyte Month , Ack
I2crbyte Year , Nack
I2cstop

Mine = Makedec(mine)
Hour = Makedec(hour)
Dat = Makedec(dat)
Month = Makedec(month)
Year = Makedec(year)
Return





Keyb:

Key = 255
Waitms 250

Temp = Pinb
Temp = Temp And &H3C

If Temp = &H3C Then Return                                  ' 


If Temp = &H38 Then                                         '-
Key = 2
Return
End If

If Temp = &H34 Then                                         '+
Key = 3
Return
End If


If Temp = &H2C Then                                         '
Key = 0
Return
End If

If Temp = &H1C Then                                         '
Key = 1
Return
End If

If Temp = &H18 Then Key = 64                                '

Return



Sun:


If Period = 0 Then
    Calc = 6 - Lnghour
Else
     Calc = 18 - Lnghour
End If

Calc = Calc / 24
Tau = Dataword1 + Calc
M = 0.9856 * Tau
M = M - 3.289

Calc1 = M * 0.0174533
Calc = Sin(calc1)
Calc2 = Calc * 1.916

Calc1 = Calc1 * 2
Calc = Sin(calc1)
Calc3 = Calc * 0.02

L = M + Calc2
L = L + Calc3
L = L + 282.634


While L > 360
L = L - 360
Wend


Calc = L * 0.0174533
Calc = Tan(calc)
Calc = Calc * 0.91764
Ra = Atn(calc)
Ra = Ra * 57.29579                                          ' 

While Ra > 360
Ra = Ra - 360
Wend


Calc = L / 90
Calc = Int(calc)
Calc = Calc * 90

Calc1 = Ra / 90
Calc1 = Int(calc1)
Calc1 = Calc1 * 90

Ra = Ra + Calc
Ra = Ra - Calc1
Ra = Ra / 15

Calc = L * 0.0174533
Calc = Sin(calc)
Calc = Calc * 0.39782

Calc2 = Asin(calc)
Calc2 = Cos(calc2)

'Cost =( -0.01454 -(calc * Sin(la * 0.0174533))) /(calc2 * Cos(la * 0.0174533))

Calc1 = La * 0.0174533
Calc1 = Sin(calc1)
Calc1 = Calc * Calc1


'calc1 = -0.01454 - calc1  '  - 90  50 
Calc1 = -0.104528 - Calc1                                   '   96 .




Calc3 = La * 0.0174533
Calc3 = Cos(calc3)
Calc3 = Calc3 * Calc2
Cost = Calc1 / Calc3


If Cost < -1 Then                                           ' 
Calc = 0
Vosh = 0 : Zah = 0
Return
End If

If Cost > 1 Then                                            ' 
Calc = 0
Vosh = 1440 : Zah = 1440
Return
End If





 '   if (cost >  1)
 '     the sun never rises on this location (on the specified date)
  '  if (cost < -1)
  '    the sun never sets on this location (on the specified date)


 '   if if rising time is desired:

Calc = Acos(cost)
Calc = Calc * 57.2957805


If Period = 0 Then Calc1 = 360 - Calc Else Calc1 = Calc
Calc1 = Calc1 / 15
Calc3 = 0.06571 * Tau
Tau = Calc1 + Ra
Tau = Tau - 6.622
Tau = Tau - Calc3
Calc = Tau - Lnghour

If Calc > 24 Then Calc = Calc - 24
If Calc < 0 Then Calc = Calc + 24

Calc = Calc + Squar
Calc = Calc * 60
Calc = Int(calc)                                            '  

If Calc > 1440 Then Calc = Calc - 1440

Return






Klimat:

Stop Watchdog

If Pinc.2 = 1 Then
1wreset
1wwrite &HCC                                                '    
1wwrite &H44
End If

M1:
'B = Pinc.1
'If B = 0 Then


If Pinc.2 = 0 Then

    Goto M1
Else

   1wreset
   1wwrite &HCC
   1wwrite &HBE                                             '    

     W = 1wread(2)
      If W > 4095 Then
         Sign = 1                                           '
        W = 65535 - W
      Else
         Sign = 0
      End If

   Calc = W * 0.0625
   If Sign = 1 Then Calc = -calc
   W = Int(calc)

End If
Start Watchdog

Return



Compens:

If W = 20 Then                                              '     w 
      Calc3 = 1                                             ' 
Else

      If W > 20 Then

         Calc2 = W - 20
         Calc3 = Calc2 / 9
         Calc2 = 20 + Calc3
         Calc1 = Log10(calc2)
         Calc3 = Calc1 / 1.3                                ' 
      Else
         Calc2 = 20 - W
         Calc3 = Calc2 / 5
         Calc2 = 20 - Calc3
         Calc1 = Log10(calc2)
         Calc3 = Calc1 / 1.3                                ' 

      End If
End If


 Calc1 = Light * Calc3                                      '
  N = Int(calc1)

Return


End